 
#include <Pilot.h>
#include <Graffiti.h>
#include <FloatMgr.h>
#include "MoneyRsc.h"

#include <SerialMgr.h>
#include <SerialLibMac.h>


#define memoDBName						"MemoDB"
#define memoDBType						'DATA'



typedef struct 
	{
   UInt	renamedCategories;
	char	categoryLabels[dmRecNumCategories][dmCategoryLength];
	Byte	categoryUniqIDs[dmRecNumCategories];
	Byte	lastUniqID;
	Byte	reserved1;
	Word	reserved2;
	char	typeLabels[20][10];
	char	tranLabels[20][20];
	} MoneyAppInfoType;

typedef MoneyAppInfoType * MoneyAppInfoPtr;
typedef CharPtr MoneyDBRecordTypePtr;

typedef struct 
	{
	Byte				displayPref;
	UInt				repeatBound;
	UInt				currentCategory;
	UInt				topVisibleRecord;
	UInt				currentRecord;
	ULong				currentRecordID;
	Byte				amountwidth,prefflags;
	Byte				mainstatuschoise;
	Char				dollarSign;
	Char				version;
	} MoneyPreferenceType;

typedef struct 
	{
	char				flags;
	UInt				checknum;
	long				amount,total;
	Int				amountc,totalc;
	DateTimeType	date;
	char				repeat;
	char				flags2;
	char				type;
	char				reserved[3];
	char				description[19];
	char				note[401];
	} TransactionType;

typedef TransactionType * TransactionTypePtr;








#define MoneyAppType		'Mony'
#define MoneyDBType		'MoDT'
#define MoneyDBName		"MoneyDB"
#define MoneyVersionNum	5
#define noRecordSelected	-1
#define noRecordSelectedID	-1
#define memosInCategoryUnknown	0xffff

#define updateCategoryChanged			0x01
#define titleReplacementChar		'#'
#define digitsForRecordPosition	6



static DateTimeType date,startdate;
static Long  todaysTotal,todaysTotalc;
static DmOpenRef		MoneyDB;
static char				CategoryName [dmCategoryLength],DollarSign='$';
static Word				RecordCategory;
static Word 			NewCategory;
static Boolean			NewCategoryEdited,JumpNote;
static Byte				MainStatusChoise=0,PrefFlags=0;
static Boolean			NegativeValue;
static Word				MemosInCategory;
static Boolean 		DeleteIt=false;
static Long				c1,c2;
static TransactionType WorkingTransaction,OldTransaction;
static Boolean			Recalculate=false,Resort=false;
static Int				CurrentView;
static UInt				CurrentRecord = noRecordSelected;
static Int				CurrentCategory = 0;
static Int				TopVisibleRecord = 0;
static UInt				RepeatBound=90;
static Byte				DisplayPref=88;
static char				mainTitle[15];
static long				CurrentTotal,CurrentTotalc;
static CharPtr 		TypeChoices[20],DescChoices[20];
static Boolean			WhichList;
static Int DateTypeCmp(DateTimeType d1, DateTimeType d2, Boolean FullCompare);
#define maxsize 10000
static char NotePadInfo[maxsize];
static Boolean errored;



static void DrawGraphics(void)
{
static Handle					ObjectBitmapHandle;
static BitmapPtr				ObjectBitmapPtr;

ObjectBitmapHandle= DmGetResource( bitmapRsc, 1070);
ObjectBitmapPtr = MemHandleLock(ObjectBitmapHandle);

WinDrawBitmap(ObjectBitmapPtr,15,36);

MemPtrUnlock(ObjectBitmapPtr);
DmReleaseResource(ObjectBitmapHandle);
	
ObjectBitmapHandle= DmGetResource( bitmapRsc, 1071);
ObjectBitmapPtr = MemHandleLock(ObjectBitmapHandle);

WinDrawBitmap(ObjectBitmapPtr,65,37);

MemPtrUnlock(ObjectBitmapPtr);
DmReleaseResource(ObjectBitmapHandle);
	
ObjectBitmapHandle= DmGetResource( bitmapRsc, 1072);
ObjectBitmapPtr = MemHandleLock(ObjectBitmapHandle);

WinDrawBitmap(ObjectBitmapPtr,115,42);

MemPtrUnlock(ObjectBitmapPtr);
DmReleaseResource(ObjectBitmapHandle);
	
}

static int DrawDot(int x,int y)
{
	static RectangleType rect;
	
rect.topLeft.x=x;
rect.topLeft.y=y;
rect.extent.x=15;
rect.extent.y=5;
WinDrawRectangle(&rect,0);
x=x+15;
return(x);
}

static void BusyNotice(char *text)
{
	RectangleType rect;
char dummy[30];
int offset;

if((PrefFlags & 4)!=4){
StrCopy(dummy,text);
offset=(FntCharsWidth(dummy,StrLen(dummy))/2);
offset=80-offset;
rect.topLeft.x=20;
rect.topLeft.y=66;
rect.extent.x=120;
rect.extent.y=30;

		WinDrawRectangle(&rect,2);
rect.topLeft.x=21;
rect.topLeft.y=67;
rect.extent.x=118;
rect.extent.y=28;

		WinEraseRectangle(&rect,2);
		FntSetFont (stdFont);
	
WinDrawChars(dummy,StrLen(dummy),offset,68);
}
}

static void BusyNoticePerc(int done,int total,int BigBar)
{
RectangleType rect;
int diff;


total++;
done++;
			diff=160*done/total;
			rect.topLeft.x=0;
			rect.topLeft.y=150;
			rect.extent.x=diff;
			rect.extent.y=9;
			WinDrawRectangle(&rect,0);
}


static void ClearPerc()
{
RectangleType rect;


			rect.topLeft.x=0;
			rect.topLeft.y=150;
			rect.extent.x=160;
			rect.extent.y=9;
			WinEraseRectangle(&rect,0);
}




static TransactionType PtrToStruct(TransactionTypePtr	ptr)
{
TransactionType	CurrentTransaction;
CurrentTransaction=*ptr;
return(CurrentTransaction);
}

static void MyStrIToA(char *string, long i)
{
	char temp[40],temp2[40];
	Word negative = 0;
	
	if (i<0){
			negative=1;
			i=i*-1;
			}
	StrIToA(temp,i);
	if (negative==1){
		StrCopy(temp2,"-\0");
		StrCat(temp2,temp);
		StrCopy(temp,temp2);
		}
	StrCopy(string,temp);
}



static void GetType(char * text, int i)
{
	MoneyAppInfoPtr	appInfoP;
	LocalID	dbID;
	LocalID appInfoID;
	UInt		cardNo;

			DmOpenDatabaseInfo(MoneyDB, &dbID, NULL, NULL, &cardNo, NULL);
			DmDatabaseInfo(0, dbID, NULL, NULL, NULL, NULL, NULL, NULL, 
			NULL, &appInfoID, NULL, NULL, NULL);
			appInfoP = MemLocalIDToLockedPtr(appInfoID, cardNo);
			StrCopy(text,appInfoP->typeLabels[i]);
			MemPtrUnlock(appInfoP);
	
 }
 
 

static void CompressedWrite(UInt *RecordNum,TransactionType	CurrentTransaction)
{
VoidHand oldH;
	VoidHand dstH;
	TransactionTypePtr dst;
dstH = DmNewHandle(MoneyDB, (ULong) sizeof(TransactionType)-400+StrLen(CurrentTransaction.note));
								if (dstH)
											{
											dst = MemHandleLock (dstH);
											DmWrite(dst, 0, &CurrentTransaction, sizeof(TransactionType)-400+StrLen(CurrentTransaction.note));
											DmAttachRecord (MoneyDB, RecordNum, dstH, &oldH);
											MemPtrUnlock(dst);
											MemHandleFree(oldH);
											} else FrmAlert(1097);
}

static void MyStrCat(char *source, char *dest)
{
if(StrLen(source)+StrLen(dest)>maxsize){
		if(errored==false)FrmAlert(1093);
		errored=true;
		} else StrCat(source,dest);

}


// This function goes through the database and generates reports, changes transactions etc.

static int Scan(int Function,Boolean Display, DateTimeType gotoDate, UInt refNum, Boolean ClearIt, Boolean SerialOut)
{
	UInt RecordNum;
	ULong MaxRecords;
	UInt cardNo,theRecord=0;
	UInt RecCatagory,attr;
	LocalID dbID;
	char lfchar[2],tabchar[2];
	VoidHand	recHandle;
	TransactionTypePtr	ptr;
	TransactionType	CurrentTransaction;
	DateTimeType currentDate;
	Boolean hasChanged,WriteIt;
	char text[500],temp[100];
		Ptr		p;
	VoidHand memoRec;
	UInt		index = 0;
	Err		error;
	Char		zero = 0;
	static DmOpenRef		MemoDB;
	errored=false;

	lfchar[0]=linefeedChr;lfchar[1]='\0'; // Set up lf and tab characters
	tabchar[0]=tabChr;tabchar[1]='\0';
	
	StrCopy(NotePadInfo,"PilotMoney Export:");
	MyStrCat(NotePadInfo,lfchar);
	
	
		switch (Function)
			{
				case 3:
					if(Recalculate==false)return(-1);
					TimSecondsToDateTime (TimGetSeconds (), &currentDate);
					FntSetFont (stdFont);
					CurrentTotal=0;todaysTotal=0;todaysTotalc=0;
					CurrentTotalc=0;
	
				break;
				}

	if(Display)ClearPerc();
	DmOpenDatabaseInfo(MoneyDB, &dbID, NULL, NULL, &cardNo, NULL);
	DmDatabaseSize(cardNo,dbID,&MaxRecords,NULL,NULL);
	if(MaxRecords>0){
	MaxRecords=MaxRecords-1;

	for(RecordNum=0;RecordNum<=MaxRecords;RecordNum++){
		if (Display)BusyNoticePerc(RecordNum,MaxRecords,true);
		recHandle = DmGetRecord(MoneyDB, RecordNum);
		if(recHandle)
			{ // rechandle
				DmRecordInfo (MoneyDB, RecordNum, &attr, NULL, NULL);
				RecCatagory = attr & dmRecAttrCategoryMask;
				ptr=MemHandleLock(recHandle);
				CurrentTransaction=PtrToStruct(ptr);
				
				switch (Function)
					{ // Switch function
						case 1:
							WriteIt=true;
						break;
						case 2:
							if ((CurrentCategory == RecCatagory) | (CurrentCategory == dmAllCategories)){
								MemHandleUnlock(recHandle);
								DmReleaseRecord(MoneyDB, RecordNum, false);
								return(RecordNum);
								}
						break;
						case 4:
										if (DateTypeCmp(CurrentTransaction.date,gotoDate,true)<=0){
																						//oldRec=theRecord;
																						theRecord=RecordNum;
																						}
									break;
						case 7:
									
									if ((CurrentCategory == RecCatagory) | (CurrentCategory == dmAllCategories))
									if (DateTypeCmp(CurrentTransaction.date,startdate,false)>=0)
									if (DateTypeCmp(CurrentTransaction.date,date,false)<=0)
									{CurrentTransaction.flags=CurrentTransaction.flags & 253;
									hasChanged=true;
									WriteIt=true;}
									break;

						case 8:
									
									if ((CurrentCategory == RecCatagory) | (CurrentCategory == dmAllCategories))
									{CurrentTransaction.flags=CurrentTransaction.flags | 2;
									hasChanged=true;
									WriteIt=true;}
									break;

						case 9:
									
									if ((CurrentCategory == RecCatagory) | (CurrentCategory == dmAllCategories))
									{CurrentTransaction.flags=CurrentTransaction.flags & 253;
									hasChanged=true;
									WriteIt=true;}
									break;

						case 10:
									
									if ((CurrentCategory == RecCatagory) | (CurrentCategory == dmAllCategories))
									if((CurrentTransaction.flags & 2)==0){
						if(ClearIt==false){
									
									StrCopy(text,"D");
									StrIToA(temp,CurrentTransaction.date.month);StrCat(text,temp);StrCat(text,"/");
									StrIToA(temp,CurrentTransaction.date.day);StrCat(text,temp);StrCat(text,"/");
									if(CurrentTransaction.date.year<2000)StrIToA(temp,CurrentTransaction.date.year-1900);
									else StrIToA(temp,CurrentTransaction.date.year-2000);
									StrCat(text,temp);
									StrCat(text,lfchar);
						MyStrCat(NotePadInfo,text);
									
									
									StrCopy(text,"T"); // Amount
									ConvertAmount(temp,CurrentTransaction.amount,CurrentTransaction.amountc,true,true);
									StrCat(text,temp);
									StrCat(text,lfchar);
						MyStrCat(NotePadInfo,text);
									
						
						
									StrCopy(text,"N"); // Check#
									StrIToA(temp,CurrentTransaction.checknum);
									StrCat(text,temp);
									StrCat(text,lfchar);
						MyStrCat(NotePadInfo,text);
									
									
									StrCopy(text,"P"); // Payee
									StrCat(text,CurrentTransaction.description);
									StrCat(text,lfchar);
						MyStrCat(NotePadInfo,text);
									
									
									
									StrCopy(text,"L"); // Category
									GetType (temp,CurrentTransaction.type);
									StrCat(text,temp);
									StrCat(text,lfchar);
						MyStrCat(NotePadInfo,text);
									
									
									if((CurrentTransaction.flags & 1)==1){
									StrCopy(text,"CX"); 
						 MyStrCat(NotePadInfo,text);}
									
									
									
									if(StrLen(CurrentTransaction.note)>0){
									StrCopy(text,"M");
									StrCat(text,CurrentTransaction.note); 
									StrCat(text,lfchar);
						MyStrCat(NotePadInfo,text);}
									
						
									StrCopy(text,lfchar);
						MyStrCat(NotePadInfo,text);
									
									StrCopy(text,"^"); // End Trans
						MyStrCat(NotePadInfo,text);
									
									
									StrCopy(text,lfchar);
									
						MyStrCat(NotePadInfo,text);
									
						
									} else {
									CurrentTransaction.flags=CurrentTransaction.flags | 2;
									hasChanged=true;
									WriteIt=true;}
									}

									break;
									
									case 11:
									
									if ((CurrentCategory == RecCatagory) | (CurrentCategory == dmAllCategories))
									if((CurrentTransaction.flags & 2)==0){
									if(ClearIt==false){

									StrIToA(temp,CurrentTransaction.date.month);StrCat(text,temp);StrCat(text,"/");
									StrIToA(temp,CurrentTransaction.date.day);StrCat(text,temp);StrCat(text,"/");
									if(CurrentTransaction.date.year<2000)StrIToA(temp,CurrentTransaction.date.year-1900);
									else StrIToA(temp,CurrentTransaction.date.year-2000);
									StrCat(text,temp);
									StrCat(text,",");
						MyStrCat(NotePadInfo,text);
									
									
									
									ConvertAmount(temp,CurrentTransaction.amount,CurrentTransaction.amountc,true,true);
									StrCopy(text,temp);
									StrCat(text,",");
						MyStrCat(NotePadInfo,text);
									
						
						
									StrIToA(temp,CurrentTransaction.checknum);
									StrCopy(text,temp);
									StrCat(text,",");
						MyStrCat(NotePadInfo,text);
									
									
									StrCopy(text,CurrentTransaction.description);
									StrCat(text,",");
						MyStrCat(NotePadInfo,text);
									
									
									
									GetType (temp,CurrentTransaction.type);
									StrCopy(text,temp);
									StrCat(text,",");
						 MyStrCat(NotePadInfo,text);
									
									
									if((CurrentTransaction.flags & 1)==1)
									StrCopy(text,"Cleared,");
									else
									StrCopy(text,"Not Cleared,");
						MyStrCat(NotePadInfo,text);
									
									
									
									if((CurrentTransaction.flags2 & 1)==1)
									StrCopy(text,"Receipt,");
									else
									StrCopy(text,"NoReceipt,");
						MyStrCat(NotePadInfo,text);
									
									
									
									if(StrLen(CurrentTransaction.note)>0)
									StrCopy(text,CurrentTransaction.note);
									else
									StrCopy(text,"");
									
									MyStrCat(NotePadInfo,text);
									
						
									StrCopy(text,lfchar);
									MyStrCat(NotePadInfo,text);
									} else {
									CurrentTransaction.flags=CurrentTransaction.flags | 2;
									hasChanged=true;
									WriteIt=true;}
									}

									break;

								case 12:
									
								if ((CurrentCategory == RecCatagory) | (CurrentCategory == dmAllCategories))
									if((CurrentTransaction.flags & 2)==0){
									if(ClearIt==false){
									StrIToA(temp,CurrentTransaction.date.month);StrCopy(text,temp);
									StrCat(text,"/");
									StrIToA(temp,CurrentTransaction.date.day);
									StrCat(text,temp);
									StrCat(text,"/");
									if(CurrentTransaction.date.year<2000)StrIToA(temp,CurrentTransaction.date.year-1900);
									else StrIToA(temp,CurrentTransaction.date.year-2000);
									StrCat(text,temp);
									StrCat(text,tabchar);
						MyStrCat(NotePadInfo,text);
						
									StrIToA(text,CurrentTransaction.checknum);
									StrCat(text,tabchar);
						MyStrCat(NotePadInfo,text);			
									
									StrCopy(text,CurrentTransaction.description);
									StrCat(text,tabchar);
						MyStrCat(NotePadInfo,text);			
									
									GetType (text,CurrentTransaction.type);
									StrCat(text,tabchar);
						MyStrCat(NotePadInfo,text);			
						
									
									ConvertAmount(text,CurrentTransaction.amount,CurrentTransaction.amountc,true,true);
									StrCat(text,tabchar);
						MyStrCat(NotePadInfo,text);
						
						if((CurrentTransaction.flags & 1)==1){
						MyStrCat(NotePadInfo,"Cleared");MyStrCat(NotePadInfo,tabchar);}
									else {
									MyStrCat(NotePadInfo,"NotCleared");
									MyStrCat(NotePadInfo,tabchar);
									}	
									
						if(StrLen(CurrentTransaction.note)>0)
									StrCopy(text,CurrentTransaction.note); 
									else StrCopy(text," "); 
						MyStrCat(NotePadInfo,text);
						MyStrCat(NotePadInfo,lfchar);			
						

									} else {
									CurrentTransaction.flags=CurrentTransaction.flags | 2;
									hasChanged=true;
									WriteIt=true;}
									}

									break;


							}
				
				MemHandleUnlock(recHandle);
				if(WriteIt)CompressedWrite(&RecordNum,CurrentTransaction);
								
				DmReleaseRecord(MoneyDB, RecordNum, WriteIt);
				
			
			
		}
			
	
		}

	
if(SerialOut==false)if(ClearIt==false){
		 	
	MemoDB = DmOpenDatabaseByTypeCreator(memoDBType, sysFileCMemo, dmModeReadWrite | dmModeShowSecret);
	if (MemoDB){
				memoRec = DmNewRecord(MemoDB, &index, StrLen(NotePadInfo)+1);
				p = MemHandleLock(memoRec);

				error = DmWrite(p, 0, NotePadInfo, StrLen(NotePadInfo)+1);
	
				ErrFatalDisplayIf(error, "Could not write to new record.");
	
				MemPtrUnlock(p);
				DmRecordInfo (MemoDB, index, &attr, NULL, NULL);
				attr &= ~dmRecAttrCategoryMask;				// Remove all category bits
				attr |= dmUnfiledCategory;
				DmSetRecordInfo (MemoDB, index, &attr, NULL);
				// dirty flag and update the database modification count.
				DmReleaseRecord(MemoDB, index, true);
				DmCloseDatabase (MemoDB);	

				}
			}
	}

		 
		 
return(-1);
}





static void ClearScreen(void)
{
	RectangleType rect;
		rect.topLeft.x=0;
		rect.topLeft.y=0;
		rect.extent.x=160;
		rect.extent.y=140;
			WinEraseRectangle(&rect,0);
}

static void ResetDate (void)
{
	TimSecondsToDateTime (TimGetSeconds (), &date);
}

static Boolean SelectDate(char * titlep)
{
Short month,day,year;
Boolean dork;
Char title[30];

StrCopy(title,titlep);
month=date.month;
day=date.day;
year=date.year;

if (dork=SelectDay (&month, &day, &year, title))
{
date.month=month;
date.day=day;
date.year=year;
}
return dork;
}

static Boolean StartApplication(void)
{
	Int		x=5;
	UInt		cardNo;
	LocalID	dbID;
	UInt		dbAttrs;
	UInt		mode;
	Err 		error;

	SystemPreferencesType sysPrefs;
	MoneyPreferenceType prefs;
	Boolean recordFound = false;

	DateTimeType currentDate;
	TimSecondsToDateTime (TimGetSeconds (), &currentDate);
	currentDate.hour=23;
	currentDate.minute=59;


	FntSetFont (largeFont);
	WinDrawChars("PilotMoney Export",17,30,10);
	FntSetFont (stdFont);

	if (PrefGetAppPreferences (MoneyAppType, MoneyVersionNum, &prefs, 
		sizeof (MoneyPreferenceType)))
		{
		TopVisibleRecord = prefs.topVisibleRecord;
		CurrentCategory = prefs.currentCategory;
		RepeatBound = prefs.repeatBound;
		DollarSign = prefs.dollarSign;
		DisplayPref = prefs.displayPref;
		PrefFlags = prefs.prefflags;
		MainStatusChoise = prefs.mainstatuschoise;
		if ((DisplayPref & 240)==0)DisplayPref=DisplayPref | 16;
		
		
		}

		PrefGetPreferences (&sysPrefs);
	if (sysPrefs.hideSecretRecords)
		mode = dmModeReadWrite;
	else
		mode = dmModeReadWrite | dmModeShowSecret;

	ResetDate();

	error=0;
	MoneyDB = DmOpenDatabaseByTypeCreator(MoneyDBType, MoneyAppType, mode);
	if (! MoneyDB)ErrFatalDisplayIf(error, "You need to have run Money to run this application");
	error = DmOpenDatabaseInfo(MoneyDB, &dbID, NULL, NULL, &cardNo, NULL);
	ErrFatalDisplayIf(error, "Could not get database info.");
	error = DmDatabaseInfo(0, dbID, NULL, &dbAttrs, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
	ErrFatalDisplayIf(error, "Could not get database info.");


	CategoryGetName (MoneyDB, CurrentCategory, CategoryName);

	if (*CategoryName == 0)
		{
		CurrentCategory = dmAllCategories;
		}

	CurrentRecord=noRecordSelected;
	
	
	// P16. Count the records later when needed to display.
	MemosInCategory = memosInCategoryUnknown;

	if (sysPrefs.hideSecretRecords)if(PrefFlags & 1){
		FrmAlert(1098);
		return true;
		}

	
	CurrentView = mainForm;
	
	return false;
}


static void SerialIt(Int WhatToSend, Boolean SerialOut)
{
	// This USED to have the open serial port stuff in it, but I removed it
Scan(10+WhatToSend,true,WorkingTransaction.date,0,false,SerialOut);
if(FrmAlert(1097)==0)Scan(10+WhatToSend,true,WorkingTransaction.date,0,true,false);

}



static VoidPtr GetObjectPtr(Int objectID)
{
	FormPtr frm;
	
	frm = FrmGetActiveForm();
	return(FrmGetObjectPtr(frm, FrmGetObjectIndex(frm, objectID)));
}




static void ChangeCategory (Word category)
{
	// Remember what category the record is in.
	RecordCategory = category;
	
	// P16. Count the records later when needed to display.
	MemosInCategory = memosInCategoryUnknown;

	// The editForm should be updated to display the new category.
	// Send a frmUpdateEvent with our updateCategoryChanged code
	// which we defined. 
	FrmUpdateForm (editForm, updateCategoryChanged);
}



static Int DateTypeCmp(DateTimeType d1, DateTimeType d2, Boolean FullCompare)
{
	Int result;
	
	result = d1.year - d2.year;
	if (result != 0)
		{
		if ((*(int *) &d1) == -1)
			return 1;
		if ((*(int *) &d2) == -1)
			return -1;
		return result;
		}
	
	result = d1.month - d2.month;
	if (result != 0)
		return result;
	
	result = d1.day - d2.day;
	if (result != 0)
		return result;
	
	if(FullCompare==true){
	result = d1.hour - d2.hour;
	if (result != 0)
		return result;
	
	result = d1.minute - d2.minute;
	if (result != 0)
		return result;
	
	result = d1.second - d2.second;
	if (result != 0)
		return result;
	}
	
	
	return result;

}


static Int MoneyCompareRecords(TransactionTypePtr r1, 
	TransactionTypePtr r2)
{
	Int result;

	
		result = DateTypeCmp(r1->date, r2->date,true);
		
	
	return result;
}




static Int MainViewSelectCategory (void)
{
	FormPtr frm;
	Word category;
	Boolean categoryEdited;


	
	// Process the category popup list.  
	category = CurrentCategory;

	frm = FrmGetActiveForm();
	categoryEdited = CategorySelect (MoneyDB, frm, mainCategoryTrigger,
					  mainCategoryList, true, &category, CategoryName);
	
	if (categoryEdited || (category != CurrentCategory))
		{
		CurrentCategory = category;
		MemosInCategory = memosInCategoryUnknown;
		}

	return (category);
}


static void MainViewInit(void)
{
	FormPtr			frm;
	RectangleType rect;
		rect.topLeft.x=0;
		rect.topLeft.y=0;
		rect.extent.x=160;
		rect.extent.y=140;

		



	// Get a pointer to the main form.
	frm = FrmGetActiveForm();
	
	CategoryGetName (MoneyDB, CurrentCategory, CategoryName);
	CategorySetTriggerLabel (GetObjectPtr (mainCategoryTrigger), CategoryName);
	WinEraseRectangle(&rect,0);
	// Draw the form.
	FrmDrawForm(frm);
}

static void RunMoney()
{
LocalID dbID;
UInt cardNo=0;
DmSearchStateType searchInfo;
Boolean newSearch=true;
	
DmGetNextDatabaseByTypeCreator (newSearch, &searchInfo, 
sysFileTApplication, 'Mony', true, &cardNo, &dbID);
SysUIAppSwitch(0,dbID,sysAppLaunchCmdNormalLaunch,NULL);
}


static Boolean MainViewHandleEvent(EventPtr event)
{
	Boolean		handled = false;
	DateTimeType currentDate;
	FormPtr frm;
	Boolean SerialOut = false;
	
	TimSecondsToDateTime (TimGetSeconds (), &currentDate);
	currentDate.hour=23;
	currentDate.minute=59;
	
	switch (event->eType)
		{
   	case ctlSelectEvent:  // A control button was pressed and released.
	   	if (event->data.ctlEnter.controlID == mainNewButton)
	   		{
	   		SerialIt(0,SerialOut);
				handled = true;
				}
	   	if (event->data.ctlEnter.controlID == mainNewButton+1)
	   		{
	   		RunMoney();
				handled = true;
				}
	   	if (event->data.ctlEnter.controlID == 1015)
	   		{
	   		SerialIt(1,SerialOut);
				handled = true;
				}
	   	if (event->data.ctlEnter.controlID == 1019)
	   		{
	   		SerialIt(2,SerialOut);
				handled = true;
				}
	   	if (event->data.ctlEnter.controlID == 1016)
	   		{
	   		if(FrmAlert(1095)==0)Scan(9,true,WorkingTransaction.date,0,true,SerialOut);
				handled = true;
				}
	   	if (event->data.ctlEnter.controlID == 1017) // Select Date
	   		{
	   		if(SelectDate("Start Date")){
	   				startdate=date;
	   				if(SelectDate("End Date")){
	   						if(FrmAlert(1095)==0)Scan(7,true,WorkingTransaction.date,0,true,SerialOut);}
	   				}
				handled = true;
				}
	   	if (event->data.ctlEnter.controlID == 1018) // Select None
	   		{
	   		if(FrmAlert(1094)==0)Scan(8,true,WorkingTransaction.date,0,true,SerialOut);
				handled = true;
				}
	   	else if (event->data.ctlEnter.controlID == mainCategoryTrigger)
	   		{
				MainViewSelectCategory();
				handled = true;
				}
			break;
  	
  		case frmOpenEvent:	// P3. The form was told to open.
  			// P7. Initialize the main form.
  			frm=FrmGetActiveForm();
  			MainViewInit();
  			FrmDrawForm(frm);
  			DrawGraphics();
  			WinDrawLine(0,75,160,75);
  			WinDrawLine(0,73,160,73);
  			handled = true;
  			break;
			
			
		case menuEvent:		// P2. A menu item was selected.
			// The get info being the only menu item, display the info form.
			
			// First clear the menu status from the display.
			MenuEraseStatus(0);
			switch (event->data.menu.itemID)
					{
					case 100:
						handled = true;
						break;

					
					}
			handled = true;
			break;
		}
	return(handled);
}


/***********************************************************************
 *
 * FUNCTION:    ApplicationHandleEvent
 *
 * DESCRIPTION: P3. This routine loads a form resource and sets the event handler for the form.
 *
 * PARAMETERS:  event - a pointer to an EventType structure
 *
 * RETURNED:    True if the event has been handled and should not be
 *						passed to a higher level handler.
 *
 ***********************************************************************/
static Boolean ApplicationHandleEvent(EventPtr event)
{
	FormPtr	frm;
	Int		formId;
	Boolean	handled = false;

	if (event->eType == frmLoadEvent)
		{
		// Load the form resource specified in the event then activate the form.
		formId = event->data.frmLoad.formID;
		frm = FrmInitForm(formId);
		FrmSetActiveForm(frm);

		// Set the event handler for the form.  The handler of the currently 
		// active form is called by FrmDispatchEvent each time it receives an event.
		switch (formId)
			{
			case mainForm:
				FrmSetEventHandler(frm, MainViewHandleEvent);
				break;
		
			}
		handled = true;
		}
	
	return handled;
}

static void StopApplication(void)
{
		
	FrmCloseAllForms ();
	DmCloseDatabase(MoneyDB);

}





/***********************************************************************
 *
 * FUNCTION:		EventLoop
 *
 * DESCRIPTION:	A simple loop that obtains events from the Event
 *						Manager and passes them on to various applications and
 *						system event handlers before passing them on to
 *						FrmDispatchEvent for default processing.
 *
 * PARAMETERS:		None.
 *
 * RETURNED:		Nothing.
 *
 ***********************************************************************/
static void EventLoop(void)
{
	EventType	event;
	Word			error;
	
	do
		{
		// Get the next available event.
		EvtGetEvent(&event, evtWaitForever);
		
		// Give the system a chance to handle the event.
		if (! SysHandleEvent(&event))

			// P2. Give the menu bar a chance to update and handle the event.	
			if (! MenuHandleEvent(NULL, &event, &error))

				// P3. Give the application a chance to handle the event.
				if (! ApplicationHandleEvent(&event))

					// P3. Let the form object provide default handling of the event.
					FrmDispatchEvent(&event);
		}
	while (event.eType != appStopEvent);
}



/***********************************************************************
 *
 * FUNCTION:		PilotMain
 *
 * DESCRIPTION:	This function is the equivalent of a main() function
 *						under standard C.  It is called by the Emulator to begin
 *						execution of this application.
 *
 * PARAMETERS:		cmd - command specifying how to launch the application.
 *						cmdPBP - parameter block for the command.
 *						launchFlags - flags used to configure the launch.			
 *
 * RETURNED:		Any applicable error codes.
 *
 ***********************************************************************/
DWord PilotMain(Word cmd, Ptr cmdPBP, Word launchFlags)
{
int err;

		if (cmd == sysAppLaunchCmdNormalLaunch)
		{
		err=StartApplication();
		if(err)return(err);
			FrmGotoForm(mainForm);
				
			// Start the event loop.
			EventLoop();
			
			// P5. Clean up before exiting the applcation.
			StopApplication();
			
		}


	return 0;
}
